unit demochild;
{
   Demo of TMultiDoc component.
   
   The child form.

   This show how to use the TMultiDoc component and
   the function to implement to better mimic the MDI
   interface.

   This very simple demo can be used as a skeleton
   for a new application.
}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons, PairSplitter;

type

  { Tf_child }

  Tf_child = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    MainPanel: TPanel; // only component in this panel are viewed at run time
    Panel2: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormMouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
    FonWantFocus: TNotifyEvent;
  public
    { public declarations }
    {
      Use this event to signal to the main form we want the focus.
      We cannot do that in TChildDoc because the base TPanel do not receive the mouse event.
    }
    Property onWantFocus : TNotifyEvent read FonWantFocus write FonWantFocus;
  end; 

var
  f_child: Tf_child;

implementation

{ Tf_child }

procedure Tf_child.Button1Click(Sender: TObject);
begin
  memo1.lines.Add(Button1.Caption);
end;

procedure Tf_child.FormMouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Assigned(FonWantFocus) then FonWantFocus(self);
end;

initialization
  {$I demochild.lrs}

end.

